---
Name: "sledgehammer-8-install"
Description: "Install bootenv for building Sledgehammer 8 images"
Documentation: |
  This BootEnv is used as the basis for building Sledgehammer, our in-memory discovery
  and inventory management environment.  This bootenv is reponsible for performing
  a basic CentOS install on a sacrificial machine.  The tasks that run after the install
  has finished are responsible for stripping out everything we do not need for Sledgehammer
  to boot as an in-memory OS image and packaging everything up for distribution.
Loaders:
  amd64-uefi: EFI/BOOT/BOOTX64.EFI
  arm64-uefi: EFI/BOOT/BOOTAA64.EFI
OS:
  Name: alma-8
  Family: redhat
  Codename: alma
  Version: "8"
  SupportedArchitectures:
    x86_64:
      Kernel: images/pxeboot/vmlinuz
      Initrds:
        - images/pxeboot/initrd.img
      BootParams: >-
        ksdevice=bootif
        ks={{.Machine.Url}}/sledgehammer.ks
        method={{.Env.InstallUrl}}
        inst.geoloc=0
        {{.ParamExpand "kernel-options"}}
        --
        {{.ParamExpand "init-options"}}
    aarch64:
      Kernel: images/pxeboot/vmlinuz
      Initrds:
        - images/pxeboot/initrd.img
      BootParams: >-
        ksdevice=bootif
        ks={{.Machine.Url}}/sledgehammer.ks
        method={{.Env.InstallUrl}}
        inst.geoloc=0
        {{.ParamExpand "kernel-options"}}
        --
        {{.ParamExpand "init-options"}}
    ppc64le:
      Loader: "core.elf"
      Kernel: "ppc/ppc64/vmlinuz"
      Initrds:
        - "ppc/ppc64/initrd.img"
      BootParams: >-
        ksdevice=bootif
        ks={{.Machine.Url}}/sledgehammer.ks
        method={{.Env.InstallUrl}}
        inst.geoloc=0
        {{.ParamExpand "kernel-options"}}
        --
        {{.ParamExpand "init-options"}}
Templates:
  - ID: "default-pxelinux.tmpl"
    Name: "pxelinux"
    Path: "pxelinux.cfg/{{.Machine.HexAddress}}"
  - ID: "default-ipxe.tmpl"
    Name: "ipxe"
    Path: "{{.Machine.Address}}.ipxe"
  - ID: "default-pxelinux.tmpl"
    Name: "pxelinux-mac"
    Path: 'pxelinux.cfg/{{.Machine.MacAddr "pxelinux"}}'
  - ID: "default-ipxe.tmpl"
    Name: "ipxe-mac"
    Path: '{{.Machine.MacAddr "ipxe"}}.ipxe'
  - ID: "default-grub.tmpl"
    Name: "grub"
    Path: "grub/{{.Machine.Address}}.cfg"
  - ID: "default-grub.tmpl"
    Name: "grub-mac"
    Path: 'grub/{{.Machine.MacAddr "grub"}}.cfg'
  - ID: default-grub.tmpl
    Name: grub-secure
    Path: '{{.Env.PathFor "tftp" ""}}/EFI/BOOT/grub.cfg'
  - Name: "sledgehammer.ks"
    Path: "{{.Machine.Path}}/sledgehammer.ks"
    Contents: |
      lang en_US.UTF-8
      keyboard us
      timezone UTC
      auth --useshadow --enablemd5
      # rebar1
      rootpw --iscrypted $1$UwJdGUMy$ORqjDQIW//wt7sWY.xG9M0
      selinux --permissive
      firewall --disabled
      {{range .MachineRepos}}
      {{.Install}}
      {{end}}
      bootloader --location=mbr
      zerombr
      clearpart --all
      {{if (eq .Machine.Arch "ppc64le")}}
      autopart
      {{else}}
      part /boot --fstype ext4 --size=512
      part /boot/efi --fstype vfat --size=512
      part / --fstype ext4 --size=1 --grow
      {{end}}
      text
      poweroff
      %packages
      OpenIPMI
      OpenIPMI-tools
      audit
      authconfig
      basesystem
      bash
      bsdtar
      busybox
      bzip2
      coreutils
      conntrack
      cpio
      curl
      dhclient
      {{if (ne .Machine.Arch "ppc64le")}}
      dmidecode
      {{end}}
      dnf
      dosfstools
      dpkg
      e2fsprogs
      {{if (ne .Machine.Arch "ppc64le")}}
      efibootmgr
      {{end}}
      file
      filesystem
      firewalld
      fuse
      fuse-libs
      fuse-ntfs-3g
      gdisk
      glibc
      glibc-common
      gzip
      hostname
      initscripts
      iproute
      iproute-tc
      iprutils
      iptables
      iputils
      jq
      kbd
      kernel
      kernel-tools
      kexec-tools
      less
      libssh2
      libsysfs
      libtomcrypt
      libtommath
      libyaml
      libxslt
      linux-firmware
      lldpd
      lshw
      lvm2
      man-db
      mdadm
      {{if (eq .Machine.Arch "amd64")}}
      grub2-efi-x64
      shim-x64
      microcode_ctl
      {{end}}
      ncurses
      ncurses-compat-libs
      nfs-utils
      ntfs-3g
      ntfsprogs
      openssh-clients
      openssh-server
      openssl-libs
      parted
      passwd
      pciutils
      perl-interpreter
      policycoreutils
      procps-ng
      python2
      python2-pyyaml
      python36
      python3-oauthlib
      python3-pip
      python3-pyyaml
      python3-requests
      rootfiles
      rpm
      rsyslog
      selinux-policy-minimum
      setup
      shadow-utils
      squashfs-tools
      socat
      sudo
      systemd
      systemd-networkd
      tar
      tftp
      tpm2-tools
      unzip
      usbutils
      util-linux
      vim-enhanced
      wget
      which
      xfsdump
      xfsprogs
      xorriso
      xz
      yum
      zlib
      zstd
      {{ range (.Param "sledgehammer/extra-packages") }}
      {{ . }}
      {{ end }}
      %end

      %pre
      {{ range $intf := .Param "sledgehammer/extra-ifs" }}
      nmcli con add type ethernet con-name {{ $intf }} ifname {{ $intf }}
      {{end}}
      %end

      %post
      cat >/etc/selinux/config <<EOF
      SELINUX=permissive
      SELINUXTYPE=minimum
      EOF
      {{template "reset-workflow.tmpl" .}}
      {{template "runner.tmpl" .}}
      %end
